(in-package :om)

(defvar *draw-grill-number* nil)

 
(defmethod draw-object ((self grap-chord-seq) view x y zoom minx maxx miny maxy slot size linear? staff grille-p chnote)
  (let* (endxms previous)
    (om-with-font (get-font-to-draw 0)
       (loop for i from 0 to (- (length (inside self)) 1)
             do (let ((cur-chord (nth i (inside self)))
                      (next-chord (nth (+ i 1) (inside self))))
                  (when (or (null next-chord)
                            (and (x next-chord) (x cur-chord)
                                 (>= (round (* zoom (x next-chord)) ) minx)
                                 (<= (round (* zoom (x cur-chord) )) maxx)))
                    (draw-object cur-chord view x y zoom minx maxx miny maxy slot size nil staff grille-p chnote)
                    (when (and *om-tonalite* (not *draw-mini-pict*))
                      (draw-modulation self cur-chord previous x y zoom size view) ))
                  (setf previous cur-chord))))
    (when (and grille-p (> (ms2pixel grille-p (/ size 4) zoom) 1))
      (setf endxms (* (ceiling (pixel2ms (- maxx x)  (/ size 4) zoom) 1000) 1000))
      (om-with-fg-color view *om-gray-color* 
        (om-with-line '(2 2)
          (loop for i from 0 to endxms  by grille-p 
                 for n = 1 then (+ n 1) do
                 do
                (let ((posx (+ x (ms2pixel i (/ size 4) zoom))))
                  (when *draw-grill-number* (om-with-font *om-def-font-face* (om-draw-string (+ posx 1) (+ miny (* size 0.38)) (format nil "~a" n))));add draw nth-grill ws 16.7.2019
                  (om-draw-line posx  miny  posx  maxy))))))
    (when (and (name (reference self)) (stringp (name (reference self))))
      (om-with-font (get-font-to-draw 6)
                    (om-draw-string (- x 12) (+ y (line2pixel (+ 10 (posy (last-elem (staff-list staff))))
                                                              t (/ size 4)) 
                                                (/ size -8))
                                    (name (reference self)))))
    (collect-rectangles self)
    (draw-extras self view size staff)))





(defmethod edit-step-grille ((self chordseqPanel)) 
  (when (grille-p self) 
    (let ((Mydilog (om-make-window 'om-dialog
                                   :size (om-make-point 190 120)
                                   :window-title "Grille step"
                                   :resizable nil :maximize nil :minimize nil
                                   :font *om-default-font1*
                                   :window-show nil
                                   :position :centered))
          (step (om-make-dialog-item 'om-editable-text (om-make-point 20 26) (om-make-point 50 12)
                                     (format () (format nil "~D" (grille-step self)))
                                     :font *om-default-font1*
                                     :focus nil)))
      (om-add-subviews mydilog 
                       (om-make-dialog-item 'om-static-text (om-make-point 15 5) (om-make-point 80 18) "Step [ms]"           
                                            :font *om-default-font2*
                                            :bg-color *om-window-def-color*)
                       
                       (om-make-dialog-item 'om-button (om-make-point 100 8) (om-make-point 80 20) "Cancel"
                                            :di-action (om-dialog-item-act item
                                                         (declare (ignore item)) (om-return-from-modal-dialog mydilog ())))
                       (om-make-dialog-item 'om-button (om-make-point 100 36) (om-make-point 80 20) "OK"
                                            :di-action (om-dialog-item-act item
                                                         (declare (ignore item))
                                                         (when (not (equal "" (om-dialog-item-text step))) 
                                                           (let ((rep (read-from-string (om-dialog-item-text step))))
                                                             (if (and (integerp rep) (> rep 0))
                                                               (progn
                                                                 (setf (grille-step self) rep)
                                                                 (set-edit-param (om-view-container self) 'grillestep  rep)
                                                                 (om-invalidate-view self t))
                                                               (om-beep-msg (string+ "Bad step value ! (" (om-dialog-item-text step) ")" )))))
                                                         (om-return-from-modal-dialog mydilog ()))
                                            ;:focus t
                                            :default-button t
                                            )
                       (om-make-dialog-item 'om-check-box (om-make-point 15 80) (om-make-point 140 15) "draw grillnumbers?" 
                                          :di-action #'(lambda (item)
                                                        (setf *draw-grill-number* (om-checked-p item)) (om-invalidate-view self t))
                                          :value *draw-grill-number*
                                          :checked-p *draw-grill-number*
                                          )

                       step)
      (om-modal-dialog mydilog))))

